// Optimisation des parametres d'un second ordre
// avec la fonction fminsearch

function y=cost_for_fminsearch(x)
    context = ["K="+string(x(1)) "tau="+string(x(2)) "tau2="+string(x(3))];

    // On impose un cout infini si on sort de nos bornes de recherche.
    if x(1) < 0 | x(2) < 0 | x(3) < 0 then
        y=%inf
        return
    end

    try
        // Ouverture du diagramme => cree une variable scs_m
        importXcosDiagram(pwd()+"/Asserv_2nd_ordre.zcos");
        // Changement du contexte
        scs_m.props.context = context;
        // Simulation
        xcos_simulate(scs_m, 4);
    catch
        disp("Error during xcos Simulation ...");
        error("cost function failed.")
        y = %inf;
        return
    end

    res_ref = ones(40,1);
    y = norm(res.values - res_ref)^2;
    e = get("costPolyline");
    
    e.data(:, 2) = res.values;
endfunction

f = gcf();
plot([0, 3.9], [1, 1], "r");
plot([0:0.1:3.9], zeros(40, 1));
e = gce();
e.children(1).tag = "costPolyline";
a = gca();
a.data_bounds = [0, 0 ; 4, 1.8]


opt = optimset( "Display" , "iter" );
[x fval] = fminsearch ( cost_for_fminsearch , [0 0 0] , opt );
//[x fval] = fminsearch ( cost_for_fminsearch , [1 1 1] , opt );
//x  =
//
//    0.9999876    0.0202413    0.0001129
